-- kalender function's         
-- sequence last_year = {<dag>,<maand>,<jaar>} b.v. {1,5,2000}
-- function dagen(sequence last_year) -- aantal dagen vanaf 1-1-1989
-- function datum(integer dag)        -- aantal dagen -> datum (year)
-- function dagweek(integer dagen)    -- dag nummer (1=maandag .. 7 =zondag)
-- function week_nummer(sequence last_year)  -- geeft weeknummer van de gegeven datum
-- function zaterdag_in_week(integer week_no,sequence last_year) -- geeft datum voor de zaterdag in week nummer 
-- function dagno_in_maand(integer dag, sequence last_year)      -- geeft week van de maand waarin de dag valt
-- function dag_in_maand(integer dag, integer dag_no,sequence last_year) -- geeft aantaldagen voor n dag in k week van maand,jaar

-- function text_maand(sequence data) -- geeft textstring voor een maand
-- procedure display_maand(sequence data) -- beeld een maand of op scherm
  
function mod(integer a,integer b)
return a-floor(a/b) * b 
end function     

function schrikkeljaar(integer jaar)
if ((mod(jaar,4)=0) and (mod(jaar,100)!=0))or(mod(jaar,400)=0)
then return 1
end if
return 0
end function 

constant DAY=1 , MONTH=2 , YEAR=3   
constant maand={31,28,31,30,31,30,31,31,30,31,30,31}  
constant dag={"maandag","dinsdag","woensdag","donderdag","vrijdag","zaterdag","zondag"}
constant maanden={"januari","februari","maart","april","mei","juni","juli","augustus","september","oktober","november","december"}
constant first_year={1,1,1990} -- is een maandag eerste dag van de week  

global function dagweek(integer dagno)    -- dag nummer (1=maandag .. 7 =zondag)
return mod(dagno-1,7)+1
end function

function dagmaand(sequence year)          -- aantal dagen in de maand
if year[MONTH]=2 then
   return maand[2]+schrikkeljaar(year[YEAR])
else
   return maand[year[MONTH]]
end if
end function
      
function dagjaar(sequence year)           -- aantal dagen in jaar
integer k , tot
k=year[MONTH]-1 
tot=year[DAY]
if k != 0 
then for i=1 to k do
       year[MONTH]=i 
       tot=tot+dagmaand(year) 
     end for
end if
return tot
end function

global function dagen(sequence last_year)        -- aantal dagen vanaf 1-1-1989
integer somt somt = 0
if first_year[YEAR] != last_year[YEAR] 
then for i = first_year[YEAR] to last_year[YEAR]-1
     do  somt = somt + 365 + schrikkeljaar(i) 
     end for
end if   
return dagjaar(last_year) + somt      
end function

global function datum(integer dag)               -- aantal dagen -> datum (year)
sequence maanden
integer  dagm,mnd,jaar
 maanden=maand
-- datum wordt bepaald door terug naar first_year tereken
jaar = first_year[YEAR]
dagm = 365
while dag > dagm do  
      dag -= dagm
      jaar+= 1                      
      dagm = (365 + schrikkeljaar(jaar))
end while               
-- de maand
mnd = 1  
maanden[2] = maanden[2]+schrikkeljaar(jaar)
while dag > maanden[mnd] do
   dag -= maanden[mnd]   
   mnd += 1
end while
-- de dag 
  
return {dag,mnd,jaar}
end function                            

-- geeft weeknummer van de gegeven datum
global function week_nummer(sequence last_year)  
sequence first_of_year
integer tot_dag_first , tot_dag_last , tot_diff , dag_cor ,i ,tot_dag
first_of_year=1&1&last_year[YEAR]  
tot_dag_first=dagen(first_of_year)
tot_dag_last=dagen(last_year) 
i=dagweek(tot_dag_first)  
if i > 4
then dag_cor=0
else dag_cor=1
end if 
tot_dag=tot_dag_last - tot_dag_first  + (dagweek(tot_dag_first)-1)
tot_diff=floor(tot_dag/7)+dag_cor 
if tot_diff=53 
then tot_dag_last=dagen(31&12&last_year[YEAR])
     tot_dag=dagweek(tot_dag_last)
     if tot_dag<4
     then tot_diff = 1
     end if
elsif tot_diff<=0
then tot_diff=week_nummer(31&12&last_year[YEAR]-1)
end if
return tot_diff                       
end function

function dag_in_weeknummer(integer dag_no, integer week_no , sequence last_year)
integer last_week , i , tot_dagen
last_year[DAY]=1 last_year[MONTH]=1
tot_dagen=dagen(last_year)
last_week=week_nummer(last_year)
i        =dagweek(tot_dagen)
tot_dagen+=dag_no-1
if last_week=1 then
 tot_dagen+=1-i
else           
 tot_dagen+=8-i
end if 
tot_dagen+=7*(week_no-1)
return tot_dagen
end function

-- geeft datum voor de zaterdag in week nummer 
global function zaterdag_in_week(integer week_no,sequence last_year)
return datum(dag_in_weeknummer(6,week_no,last_year))
end function   

global function dag_in_maand(integer dag, integer dag_no,sequence last_year)
integer tot_dagen , verschil , limit 
last_year[DAY]=1
tot_dagen=dagen(last_year)                  
limit=tot_dagen+dagmaand(last_year)     
verschil=dag-dagweek(tot_dagen)
if verschil<0 then dag_no+=1 end if
tot_dagen=tot_dagen + verschil + (dag_no-1) * 7
if tot_dagen >= limit then
return 0
else
return tot_dagen
end if
end function                      

---- geeft datum voor n de zaterdag in de maand
--function zaterdag_in_maand(integer zaterdag_no,sequence last_year)
--return datum(dag_in_maand(6,zaterdag_no,last_year))
--end function   

global function dagno_in_maand(integer dag, sequence last_year)
integer tot_dagen , verschil  , i
i=dagen(last_year)                  
last_year[DAY]=1
tot_dagen=dagen(last_year)                  
verschil=dag-dagweek(tot_dagen)  
tot_dagen=tot_dagen + verschil 
i=floor((i-tot_dagen)/7)
if verschil<0 then
 return i
else
 return i+1
end if
end function

---- geeft aan de hoeveelste zaterdag in de maand 
--function zaterdagno_in_maand(sequence last_year)
--return dagno_in_maand(6,last_year)
--end function   

function gen_maand(sequence last_year)
sequence data_maand -- [7 dagen + weeknumber][ 6 kollomen per dag]
sequence data  , maand_dagen
integer  dagen , i , j , weeknumber              
data_maand=repeat(repeat(0,6),8)   
maand_dagen=maand
maand_dagen[2]=maand_dagen[2]+schrikkeljaar(last_year[YEAR])
data=datum(dag_in_maand(7,1,last_year)) -- zondag
weeknumber=week_nummer(data)

j = 1
while j<=7 do
  dagen =data[DAY]-7+j    -- begin bij de maandag
  i = 0
  while i<7 do 
    i=i+1
    if dagen<=maand_dagen[last_year[MONTH]] and dagen >= 1
    then data_maand[j][i]=dagen    
    --else data_maand[j][i]=0
    end if    
    dagen=dagen+7           -- week verder
  end while
  j=j+1
end while
-- zet week nummers

data_maand[8][1]=weeknumber
for k = 2 to 6 do         
if data_maand[7][k] then
data_maand[8][k]=week_nummer(data_maand[7][k]&last_year[MONTH]&last_year[YEAR])
elsif data_maand[1][k] then
data_maand[8][k]=week_nummer(data_maand[1][k]&last_year[MONTH]&last_year[YEAR])
end if
end for
return data_maand
end function

global function text_maand(sequence data)
sequence display , dagen_maand , text_display
dagen_maand=gen_maand(data)
text_display={sprintf("%8s %4d",{maanden[data[MONTH]],data[YEAR]})}
for k=1 to 7 do            -- dagen
  display=sprintf("%9s ",{dag[k]})
  for i=1 to 6 do          -- datum's  
    if   dagen_maand[k][i] --als datum is 0  geef spatie's
    then display=display&sprintf("%2d ",dagen_maand[k][i])
    else display=display&"   "
    end if 
  end for     
  text_display=append(text_display,display)     -- voeg een new line toe
end for                     
display="Week no : "     
for k=1 to 6 
do if dagen_maand[8][k] = 0
   then  display=display&"   " -- weeknumber is 0 geef spatie's
   else  display=display&sprintf("%2d ",dagen_maand[8][k])
   end if
end for
return append(text_display,display)
end function
                
global procedure display_maand(sequence data)
sequence display = text_maand(data)
for i = 1 to length(display) do
printf(1,"%s\n",{display[i]})   -- beeld af
end for                          

end procedure



