-- Porteble_Euphoria keywords and routines built in to the interpreter.

global constant keywords = {
    "if", "end", "then", "procedure", "else", "for", "return",
    "do", "elsif", "while", "type", "constant", "to", "and", "or","xor",
    "exit", "function", "global", "by", "not", "include", "in",
    "with", "without", "ignore","ifdef","elsedef","elseifdef","enddef"}

global constant builtins = {
    --buildin.c
    "integer", "sequence", "object", "atom", "bytesequence",
    "lower", "upper", "value", "set_rand", "rand", "trace", "platform",
    "sqrt", "sin", "cos", "tan", "log", "remainder", "power", "floor", 
    "arctan", "and_bits", "or_bits", "xor_bits", "not_bits",
    "abort", "call", "routine_id", "call_proc", "call_func", "call_back", 
    --file.c
    "putc", "puts", "print", "printf", "sprintf",
    "getc", "gets", "get_bytes", "open", "close",
    "where", "seek", "flush", "lockf", "unlockf","renamef","removef",
    --sequence.c 
    "length", "append", "prepend", "insert", "remove",
    "repeat", "compare", "find", "find_from", "match", "match_from", "equal",
    "command_line", "getenv", "putenv", "system", "system_exec","system_get",
    "system_put",
    --system.c
    "time", "date", "fdate", "machine_func", "machine_proc",
    "change_dir", "current_dir", "dir", "wildcard_file", "wildcard_match",
    "clear_screen", "position", "get_position", "bk_color", "text_color",
    "cursor", "display_text_image", "save_text_image", "wrap", "dos_interrupt",
    "get_key", "wait_key", "text_mouse",
    --memory.c
    "bytes_to_int", "int_to_bytes",
    "atom_to_float32", "atom_to_float64", "float32_to_atom", "float64_to_atom",
    "allocate", "allocate_low", "free", "free_low", "mem_copy", "mem_set",
    "peek", "poke", "poke4", "peek4s", "peek4u",
    --error.c
    "crash_message", "crash_routine", "crash_file",
    --dynamdll.c
    "open_dll", "define_c_func", "define_c_proc", "define_c_var",
    "c_proc", "c_func", "message_box", "allocate_string", "peeks", "call_back" 
    }


global constant library = {
--  "all_palette",
    "allow_break",           --file.e
    "arccos",               --misc.e
    "arcsin",               --misc.e
    "bits_to_int",           --machine.e
    "check_break",           --file.e
    "custom_sort",           --sort.e
    "dagen",                 --datarout.e 
    "dag_in_maand",          --datarout.e
    "dagno_in_maand",        --datarout.e
    "dagweek",               --datarout.e
    "datum",                 --datarout.e
--  "display_image",
--  "draw_line",
--  "ellipse",
    "file_find",             --ff.e
    "get",                   --get.e
--  "get_active_page",
--  "get_all_palette",
--  "get_display_page",
    "get_mouse",             --mouse.e
--  "get_vector",
--  "graphics_mode",         --graphics.e
    "int_to_bits",           --machine.e
--  "lock_memory",           
    "mouse_events",          --mouse.e
    "mouse_pointer",         --mouse.e
    "PI",                    --misc.e
--  "palette",
--  "polygon",  
    "printuf",               --readf.e
    "printsf",               --readf.e
    "prompt_number",         --get.e
    "prompt_string",         --get.e
    "readf",                 --readf.e
--  "read_bitmap",                     
    "reverse",               --misc.e
--  "save_bitmap",
--  "save_image",
--  "save_screen",
    "scroll",                --graphics.e
--  "set_active_page",
--  "set_display_page",
--  "set_vector",                    
    "sprint",                --misc.e
    "sprintuf",              --readf.e
    "sprintsf",              --readf.e
    "sreadf",                --readf.e
    "sort",                  --sort.e
    "sound",                 --graphics.e
--  "text_rows",
--  "tick_rate",
--  "use_vesa",
    "walk_dir",              --file.e
    "video_config"           --graphics.e
    }


