-- lexical scanner  by M.S.Ter Haseborg dec 2002
--
-- Initlexi(sequence text)
--  init's lexi with a text if text is a atom and a filenumber,text from file
--                          else it is a line of text .
-- return FALSE if illegal  else {token,ident}
--
-- lexi() gives next item
-- return FALSE if illegal else {token,ident}
--
-- Endlexi() close the lexical scanner and when there are more (include file)
--                     levels it return to its caller
-- 
-- TOKEN type  is text sequence
-- IDENT types are text,getal,punct,eol,eof
--
-- special constants are LISTING_OFF direct the printing
--                       EOL_CHECK_ON means cr is a 'leesteken'
--
-- special routine   is  foutjes() print a marker at detected error state .

-- to do : scanning on deferent type of numbers as integer,float,hex,oct,bin

-- example : datums.ex

global constant TRUE=1,FALSE=0
global constant TOKEN=1,IDENT=2
global constant text=1,getal=2,punct=3,eol=4,eof=5  
global atom LISTING_OFF  = FALSE
global atom EOL_CHECK_ON = FALSE

object   line
integer  filenum,characcess,lastaccess,token,linenumber
atom     char
sequence teken 

--structure fileinfostruc
--  sequence filename
--  sequence currentline
--  integer  characcess
--  integer  linenumber
--end structure                

constant FILENAME=1,CURRENTLINE=2,CHARACCESS=3,LINENUMBER=4
sequence fileinfo={}

function cyfer(atom l)
  return (l>='0') and (l <= '9')
end function

function leesteken(atom l)
    return find(l,"()#$*-+:=<>&{}[]@!,;'.^\"")!=0
end function

function letter(atom l)
    return ((l>='a')and(l<='z'))or((l>='A')and(l<='Z'))or(l='_')
end function

-- cntrl Z
function EOF(atom l)
return l=26 
end function

-- dit hangt er vanaf hoe de file werkt lf=10 , cr=13
function EOL(atom l)
return ((l=10)or(l=13))and(EOL_CHECK_ON) 
end function

procedure foutjes()
    puts(1,"Fout: "&repeat(' ',lastaccess)&"^{"&teken&"}\n")
end procedure

procedure getnextline() 
    if filenum>=0 then
     line=gets(filenum)     
     if atom(line) then
        line={26,10} 
     else   
        if LISTING_OFF = FALSE then printf(1,"%5d %s",{linenumber,line}) end if
     end if
    else 
     if length(line)<=characcess then
        line={26,10}
     end if
    end if 
    linenumber+=1
end procedure

function getchar()
if length(line)=0 or length(line)<=characcess then
    getnextline()
    characcess=0
end if
characcess=characcess+1
return line[characcess]
end function

global function lexi()
    token=0
    while token=0 do
        lastaccess=characcess
        teken={ char } 
        if cyfer(char) then token=getal
        elsif letter(char) then token=text
        elsif leesteken(char) then token=punct
        elsif EOL(char) then token=eol
        elsif EOF(char) then token=eof 
        else  char=getchar()
        end if
    end while
    while TRUE do
    char=getchar()  
    if token=text then
          if letter(char) or cyfer(char) then
            teken=teken & char
          else
            exit
          end if
    elsif token=getal then
          if cyfer(char) then
            teken=teken & char
          else
            exit
          end if   
    elsif token=punct then
          exit
    elsif token=eol then
          exit    
    elsif token=eof then
          exit    
    else puts(1,"Program Error\n")          
    end if
    end while  
    if token=eof then
    return FALSE
    else
    return {token,teken}
    end if
end function

global function InitLexi(sequence filenumber)
if atom(filenumber) then
  filenum=filenumber
  line=""
else
  filenum=-1
  line=filenumber 
end if    
if length(fileinfo)=0 then 
  fileinfo={{filenum,"",0,0}}
else 
  fileinfo[length(fileinfo)][CURRENTLINE]=line
  fileinfo[length(fileinfo)][CHARACCESS]=characcess 
  fileinfo[length(fileinfo)][LINENUMBER]=linenumber
  fileinfo&={{filenumber,"",0,0}}
end if
linenumber=0 
characcess=0
char=getchar()
if EOF(line[characcess]) then
  return FALSE
else
  return lexi()
end if
end function    

global function EndLexi()
if length(fileinfo)>1 then
  filenum   =fileinfo[length(fileinfo)][FILENAME]
  line      =fileinfo[length(fileinfo)][CURRENTLINE]
  characcess=fileinfo[length(fileinfo)][CHARACCESS]
  linenumber=fileinfo[length(fileinfo)][LINENUMBER]
  fileinfo  =fileinfo[1..length(fileinfo)]
  char      =line[characcess]
  return lexi()
else
  return FALSE
end if
end function

