-- keys.e
--
-- dos/linux specific stuff

include graphics.e      -- cursor()
include mouse.e         -- standard mouse tools
--include machine.e
--include get.e
    
without warning

global integer 
    FileDelim,          -- file delimiter character
    editorClockId,      -- clock routine callback
    MOUSE_COL,          -- mouse x position at time of event
    MOUSE_ROW,          -- mouse y position at time of event
    MOUSE_BUTTON_STATE  -- button held or not
    
sequence 
    cursorPosition      -- cursor position
    
object  
    MOUSE_TIME          -- time of last mouse event
    
-- initial values
    editorClockId = -1  

    mouse_events( LEFT_DOWN + LEFT_UP )     -- events to poll
    MOUSE_COL = 0
    MOUSE_ROW = 0
    MOUSE_BUTTON_STATE = LEFT_UP
    MOUSE_TIME = time()
    
    cursorPosition = get_position()

global constant      
                
    BACKSPACE = 8, TAB = 9, ENTER = 13, ESC = 27,
    SHIFT_TAB = 271,

    CTRL_A = 01, CTRL_B = 02, CTRL_C = 03,
    CTRL_D = 04, CTRL_E = 05, CTRL_F = 06,
    CTRL_G = 07, CTRL_H = 08, CTRL_I = 09,
    CTRL_J = 10, CTRL_K = 11, CTRL_L = 12,
    CTRL_M = 13, CTRL_N = 14, CTRL_O = 15,
    CTRL_P = 16, CTRL_Q = 17, CTRL_R = 18,        
    CTRL_S = 19, CTRL_T = 20, CTRL_U = 21,
    CTRL_V = 22, CTRL_W = 23, CTRL_X = 24,
    CTRL_Y = 25, CTRL_Z = 26, 
                    

    F1 = 315, F2 = 316, F3 = 317, F4 = 318, F5 = 319,    
    F6 = 320, F7 = 321, F8 = 322, F9 = 323, F10 = 324,
    F11= 325, F12= 326, -- is onzin !   

    HOME = 327, UP = 328, PAGE_UP = 329, LEFT = 331,
    RIGHT = 333, END = 335, DOWN = 336, 
    PAGE_DOWN = 337, INSERT = 338, DELETE = 339, 

    CTRL_LEFT = 371, CTRL_RIGHT = 372, CTRL_END = 373,
    CTRL_HOME = 375, CTRL_PAGE_UP = 388, CTRL_PAGE_DOWN = 374,
    CTRL_UP = 397, CTRL_DOWN = 401, CTRL_INSERT = 403,
    CTRL_TAB = 404, CTRL_ENTER = 10,

    ALT_LEFT = 411, ALT_RIGHT = 413, ALT_END = 415,
    ALT_HOME = 407, ALT_PAGE_UP = 409, ALT_PAGE_DOWN = 417,
    ALT_UP = 408, ALT_DOWN = 416, ALT_INSERT = 418,
    ALT_TAB = 421, -- ALT_ENTER = 10, swapes windows

    -- shift keys (linux)
--  SHIFT_UP = 408, SHIFT_RIGHT = 413, SHIFT_DOWN = 416, SHIFT_LEFT = 411,
    -- shift keys (win32/dos32
--  SHIFT_UP = 428, SHIFT_RIGHT = 433, SHIFT_DOWN = 436, SHIFT_LEFT = 431,
    -- keys (dos32)
--  UP = 328, RIGHT = 333, DOWN = 336, LEFT = 331,

    -- emulated keys
    ALT_PRESSED = 600, ALT_RELEASED = 601,
    SHIFT_PRESSED = 603, SHIFT_RELEASED = 604,

    MOUSE_CLICK = 801, MOUSE_UP = 802, MOUSE_DRAG = 803,
    MOUSE_DOUBLE = 804, MOUSE_HELD = 805

--include os_keys
include alt_keys.e   

-- alt keys, in alpha order
global constant
    ALPHA_ALT_KEYS = { 
        ALT_A, ALT_B, ALT_C, ALT_D, ALT_E, ALT_F,
        ALT_G, ALT_H, ALT_I, ALT_J, ALT_K, ALT_L,
        ALT_M, ALT_N, ALT_O, ALT_P, ALT_Q, ALT_R,
        ALT_S, ALT_T, ALT_U, ALT_V, ALT_W, ALT_X,
        ALT_Y, ALT_Z },
    
    NUMERIC_ALT_KEYS = { 
        ALT_0, ALT_1, ALT_2, ALT_3, ALT_4,
        ALT_5, ALT_6, ALT_7, ALT_8, ALT_9 },
    
    SHIFT_KEYS = {    
        SHIFT_UP, SHIFT_RIGHT, SHIFT_DOWN, SHIFT_LEFT }
    
-- key state stuff

-- edit mode
global integer editMode
global constant
    INSERT_MODE = 0,
    OVERWRITE_MODE = 1

global integer 
--    alt_state,
    KEY_CODE,
    pendKey

-- default mode
    editMode = INSERT_MODE
--    alt_state = 0
    KEY_CODE = 0
    pendKey = 0

-- clipboard
global sequence clipboard
    clipboard = ""

-- last key pressed
global integer last_key_pressed


----------------------------------------------------------------------------
global function mouse_released()

    -- returns true if mouse left button is released

   sequence mouseState

   mouseState = get_mouse()                       
   if sequence(mouseState) then
      return mouseState[1]=4
   else
      return 0
   end if      
end function
-----------------------------------------------------------------------------
global function get_res_mouse()

   -- same as text_mouse(), except handles graphic modes
   
    object me
    me = get_mouse()
    return me
end function
----------------------------------------------------------------------------
global function natural_key( integer k )
        
        -- key pressed is not a command key (32-126)

        return ( k > 31 and k < 127 )

end function

----------------------------------------------------------------------------
global function shift_key_state()
    -- emulated shift state
    return KEY_CODE=SHIFT_PRESSED
end function


----------------------------------------------------------------------------
global function get_safe_key()
    integer key

    -- return key currently being pressed
    -- or mouse event
    -- or zero if no event

    object mouse_event, priorTime
    integer priorRow, priorCol--, key_code
               
    -- handle mouse first
    mouse_event = get_res_mouse()
    -- mouse event?
    if compare( mouse_event, -1 ) != 0 then

        -- get the column
        priorCol = MOUSE_COL
        MOUSE_COL = floor( mouse_event[2] )

        -- get the row
        priorRow = MOUSE_ROW
        MOUSE_ROW = floor( mouse_event[3] )
                     
        -- handle event
        if and_bits(mouse_event[1], LEFT_DOWN) then
            -- activate move for MOUSE_DRAG
            mouse_events( LEFT_DOWN + LEFT_UP + MOVE )

            -- change button state
            MOUSE_BUTTON_STATE = LEFT_DOWN

            priorTime = MOUSE_TIME
            MOUSE_TIME = time()

            -- double click?
            if  priorCol = MOUSE_COL
            and priorRow = MOUSE_ROW
            and MOUSE_TIME - priorTime < 0.5 then

                -- double click
                return MOUSE_DOUBLE

            else

                -- single click
                return MOUSE_CLICK
                                                
            end if

        elsif and_bits( mouse_event[1], LEFT_UP ) then

            -- disable MOVE
            mouse_events( LEFT_DOWN + LEFT_UP )

            -- change button state
            MOUSE_BUTTON_STATE = LEFT_UP

            return MOUSE_UP

        elsif and_bits( mouse_event[1], MOVE )
        and   MOUSE_BUTTON_STATE = LEFT_DOWN then

            -- make sure we didn't miss the mouse up event
            if mouse_released() then
                -- oops. we missed it. clear the state
                MOUSE_BUTTON_STATE = LEFT_UP
        
                -- pretend it just happened
                return MOUSE_UP
        
            else
                -- fake mouse event
                return MOUSE_DRAG

            end if

        end if
-+  Waarom dit gedaan is weet ik niet meer maar in win/dos werkt dit averechts
    elsif MOUSE_BUTTON_STATE = LEFT_DOWN then

        -- make sure we didn't miss the mouse up event
        if mouse_released() then
        
            -- oops. we missed it. clear the state
            MOUSE_BUTTON_STATE = LEFT_UP

            -- pretend it just happened
            return MOUSE_UP
        
        else

            -- fake mouse event
            return MOUSE_HELD

        end if
-+                  
    end if

    -- is there a pending keystroke?
    if pendKey then      
        -- return that value
        key = pendKey
        pendKey = 0

    else
        -- wait for a key
        key = get_key() 
        ifdef dos32
        if find(key,DOS_SHIFT_SET) then
        -- dos has in #417 the shift/alt keys
        -- bit 1 is right shift key
        -- bit 2 is left shift key
        -- bit 3 is cntrl
        -- bit 4 is alt key  
           if and_bits(peek(#417),3) then
              key=SHIFT_KEYS[find(key,DOS_SHIFT_SET)]
           end if
        end if
        enddef
        -- is it an alt key?
        if find( key, SHIFT_KEYS ) then
            -- make it look like an shift pressed
            -- on return, will feed actual key and set KEY_CODE to SHIFT_PRESSED
            KEY_CODE = SHIFT_PRESSED
            key = key-80-20
        elsif KEY_CODE=SHIFT_PRESSED then
            if not find( key, SHIFT_KEYS ) then
               KEY_CODE=0
            end if
        -- is it an alt key?
        elsif find( key, ALPHA_ALT_KEYS )
              or find( key, NUMERIC_ALT_KEYS ) then         
            -- make it look like an alt pressed
            -- on return, will feed actual key
            -- this makes the keys work with the menu,
            -- which expects an ALT_PRESSED to trigger it
            pendKey = key
            key = ALT_PRESSED
            KEY_CODE = key
        elsif KEY_CODE=ALT_PRESSED then
            if not find( key, ALPHA_ALT_KEYS )+find( key, NUMERIC_ALT_KEYS ) then
               KEY_CODE=0
            end if
        end if
        
    end if
    
    last_key_pressed = key
if key>0 and key<32 then ?key ~wait_key() end if       
    return key
    
end function



constant Null = {}   
----------------------------------------------------------------------------
global function watch_keys()
        
    -- return an event - key press or mouse
        
    integer keyPress

    keyPress = 0
    while keyPress <= 0 do

        -- run the clock, if defined
        if editorClockId > -1 then
            call_proc( editorClockId, Null )
        end if

        -- look for a key
        keyPress = get_safe_key()
                    
        -- toggle insert/delete mode on Insert
        -- if not part of block mode
        if  keyPress = INSERT then
            if editMode = INSERT_MODE then
                editMode = OVERWRITE_MODE
            else
                editMode = INSERT_MODE
            end if
        end if

    end while

    return keyPress

end function

----------------------------------------------------------------------------
global function alt_key_state()
--    return get_key() = ESC
   return KEY_CODE=ALT_PRESSED
end function


----------------------------------------------------------------------------
global function edit_mode()
        return editMode
end function

----------------------------------------------------------------------------
global procedure show_cursor()

    if editMode = INSERT_MODE then
        cursor( UNDERLINE_CURSOR )
    else
        cursor( BLOCK_CURSOR )
    end if

end procedure


----------------------------------------------------------------------------
global procedure hide_cursor()
    cursor( NO_CURSOR )
end procedure




